/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KukuVHostLister helps list KukuVHosts.
type KukuVHostLister interface {
	// List lists all KukuVHosts in the indexer.
	List(selector labels.Selector) (ret []*v1.KukuVHost, err error)
	// KukuVHosts returns an object that can list and get KukuVHosts.
	KukuVHosts(namespace string) KukuVHostNamespaceLister
	KukuVHostListerExpansion
}

// kukuVHostLister implements the KukuVHostLister interface.
type kukuVHostLister struct {
	indexer cache.Indexer
}

// NewKukuVHostLister returns a new KukuVHostLister.
func NewKukuVHostLister(indexer cache.Indexer) KukuVHostLister {
	return &kukuVHostLister{indexer: indexer}
}

// List lists all KukuVHosts in the indexer.
func (s *kukuVHostLister) List(selector labels.Selector) (ret []*v1.KukuVHost, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuVHost))
	})
	return ret, err
}

// KukuVHosts returns an object that can list and get KukuVHosts.
func (s *kukuVHostLister) KukuVHosts(namespace string) KukuVHostNamespaceLister {
	return kukuVHostNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KukuVHostNamespaceLister helps list and get KukuVHosts.
type KukuVHostNamespaceLister interface {
	// List lists all KukuVHosts in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KukuVHost, err error)
	// Get retrieves the KukuVHost from the indexer for a given namespace and name.
	Get(name string) (*v1.KukuVHost, error)
	KukuVHostNamespaceListerExpansion
}

// kukuVHostNamespaceLister implements the KukuVHostNamespaceLister
// interface.
type kukuVHostNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KukuVHosts in the indexer for a given namespace.
func (s kukuVHostNamespaceLister) List(selector labels.Selector) (ret []*v1.KukuVHost, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuVHost))
	})
	return ret, err
}

// Get retrieves the KukuVHost from the indexer for a given namespace and name.
func (s kukuVHostNamespaceLister) Get(name string) (*v1.KukuVHost, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kukuvhost"), name)
	}
	return obj.(*v1.KukuVHost), nil
}
